/****************************************************************************
  This file is part of Multistage2015 project
  Copyright belogs to Fred18 for module implementation and its code
  Biggest Credit goes to Vinka for his idea of Multistage.dll. None of his code was used here since his addons are all closed source.
  Credit goes to Face for having pointed me to the GetPrivateProfileString 
  Credit goes to Hlynkacg for his OrientForBurn function which was the basis on which I developed the Attitude Function.

  Multistage2015 is distributed FREEWARE. Its code is distributed along with the dll. Nobody is authorized to exploit the module or the code or parts of them commercially directly or indirectly.
You CAN distribute the dll together with your addon but in this case you MUST:
-	Include credit to the author in your addon documentation;
-	Add to the addon documentation the official link of Orbit Hangar Mods for download and suggest to download the latest and updated version of the module.
You CAN use parts of the code of Multistage2015, but in this case you MUST:
-	Give credits in your copyright header and in your documentation for the part you used.
-	Let your project be open source and its code available for at least visualization by other users.
You CAN NOT use the entire code for making and distributing the very same module claiming it as your work entirely or partly.
You CAN NOT claim that Multistage2015 is an invention of yourself or a work made up by yourself, or anyhow let intend that is not made and coded by the author.
You install and use Multistage2015 at your own risk, author will not be responsible for any claim or damage subsequent to its use or for the use of part of it or of part of its code.



 */
// ==============================================================
//						MultiStage2015
//                  
//					       By Fred18
//                  
//
// Multistage2015.h
// ==============================================================


#define _CRT_SECURE_NO_WARNINGS
#define _CRT_NONSTDC_NO_DEPRECATE
#define ORBITER_MODULE


#define MAXLEN 4096
#define TBOOSTER 0
#define TSTAGE 1
#define TPAYLOAD 2
#define TFAIRING 3
#define TINTERSTAGE 4
#define TLES 5

#define STAGE_SHUTDOWN 1
#define STAGE_IGNITED 2
#define STAGE_WAITING 3

#define FXMACH 0
#define FXVENT 1
//#define ORBITER_MODULE

#define TLMSECS 7200

#include <iostream>
#include <fstream>
#include <string>
#include "OrbiterSoundSDK40.h"
#include <time.h>
#include "orbitersdk.h"
using namespace std;

struct VECTOR4{
	double x;
	double y;
	double z;
	double t;
};
struct VECTOR2{
	double x;
	double y;
};
struct CUTOFF_CONDITIONS{
	double T;
	int stage;
	int rem_stages;
	double r_T;
	double rdot_T;
	double remBT[10];
};
struct BATTS{
	bool wBatts;
	double MaxCharge;
	double CurrentCharge;
};
struct EXPBOLT{
	VECTOR3 pos;
	VECTOR3 dir;
	char pstream[MAXLEN];
	double anticipation;
	bool wExpbolt;
	THRUSTER_HANDLE threxp_h;
};
struct MISC{
	double COG;
	int GNC_Debug;
	bool telemetry;
	int Focus;
	bool thrustrealpos;
};
struct TEX{
	char TextureName[MAXLEN][16];
	SURFHANDLE hTex[16];
	};
struct PARTICLE{
		char ParticleName[MAXLEN];
		PARTICLESTREAMSPEC Pss;
		double GrowFactor_size;
		double GrowFactor_rate;
		bool Growing;
		
	};

struct PSGROWING{
		PSTREAM_HANDLE psh[2];
		PARTICLESTREAMSPEC pss;
		double GrowFactor_size;
		double GrowFactor_rate;
		THRUSTER_HANDLE th;
		VECTOR3 pos;
		bool growing;
		int status;
		bool counting;
		double doublepstime;
		double basesize;
		double baserate;
		VECTOR3 basepos;
	};
struct BOOSTER{
	//mandatory
	int N;
	char meshname[MAXLEN];
	VECTOR3 off;
	double height;
	double diameter;
	double thrust;
	double emptymass;
	double fuelmass;
	double burntime;	
	double angle;
	//unmandatory
	double burndelay;
	VECTOR3 speed;
	VECTOR3 rot_speed;
	char module[MAXLEN];
	VECTOR3 eng[4];
	double engine_phase[32];
	double engine_amp[32];
	double freq[32];
	double eng_diameter;
	char eng_tex[MAXLEN];
	char eng_pstream1[MAXLEN];
	char eng_pstream2[MAXLEN];
	VECTOR3 eng_dir;
	THGROUP_HANDLE Thg_boosters_h;
	EXPBOLT expbolt;
	//derived parameters
	double isp;
	double volume;
	PROPELLANT_HANDLE tank;
	THRUSTER_HANDLE th_booster_h[10];
	MESHHANDLE msh_h[10];
	int msh_idh[10];
	int nEngines;
	double currDelay;
	VECTOR3 curve[10];
	double IgnitionTime;
	bool Ignited;
	bool PSSdefined;
	bool ParticlesPacked;
	int ParticlesPackedToEngine;
};
struct INTERSTAGE{
	//mandatory
	char meshname[MAXLEN];
	VECTOR3 off;
	double height;
	double diameter;
	double volume;
	double emptymass;
	//unmandatory
	double separation_delay;
	VECTOR3 speed;
	VECTOR3 rot_speed;
	char module[MAXLEN];
	MESHHANDLE msh_h;
	int msh_idh;
	double currDelay;
	};
struct ADAPTER{
	//mandatory
	char meshname[MAXLEN];
	VECTOR3 off;
	double height;
	double diameter;
	double emptymass;
	
	MESHHANDLE msh_h;
	int msh_idh;
	
	};

struct LES{
	char meshname[MAXLEN];
	VECTOR3 off;
	double height;
	double diameter;
	double emptymass;
	VECTOR3 speed;
	VECTOR3 rot_speed;
	char module[MAXLEN];
	MESHHANDLE msh_h;
	int msh_idh;
	double volume;
};
struct ULLAGE{
	bool wUllage;
	bool ignited;
	double thrust;
	double anticipation;
	double overlap;
	int N;
	double angle;
	VECTOR3 pos;
	VECTOR3 dir;
	double length;
	double diameter;
	char tex[MAXLEN];
	THRUSTER_HANDLE th_ullage;
	double rectfactor;
};
struct STAGE{
	//mandatory
	char meshname[MAXLEN];
	VECTOR3 off;
	double height;
	double diameter;
	double thrust;
	double emptymass;
	double fuelmass;
	double burntime;	
	//unmandatory
	double waitforreignition;
	BATTS batteries;
	double ignite_delay;
	VECTOR3 speed;
	VECTOR3 rot_speed;
	char module[MAXLEN];
	double pitchthrust;
	double yawthrust;
	double rollthrust;
	VECTOR3 eng[32];
	double engine_phase[32];
	double engine_amp[32];
	double freq[32];
	VECTOR4 engV4[32];
	double eng_diameter;
	char eng_tex[MAXLEN];
	char eng_pstream1[MAXLEN];
	char eng_pstream2[MAXLEN];
	VECTOR3 eng_dir;
	ULLAGE ullage;
	EXPBOLT expbolt;
	//derived parameters
	double isp;
	double volume;
	PROPELLANT_HANDLE tank;
	THRUSTER_HANDLE th_main_h[32],th_att_h[2];
	MESHHANDLE msh_h;
	int msh_idh;
	int nEngines;
	bool wInter;
	int IntIncremental;
	INTERSTAGE interstage;
	bool Ignited;
	double currDelay;
	double IgnitionTime;
	bool reignitable;
	bool DenyIgnition;
	bool wBoiloff;
	int StageState;
	bool ParticlesPacked;
	int ParticlesPackedToEngine;
};
struct PAYLOAD{
	//mandatory
	char meshname[MAXLEN];
	char meshname0[MAXLEN];
	char meshname1[MAXLEN];
	char meshname2[MAXLEN];
	char meshname3[MAXLEN];
	char meshname4[MAXLEN];
	
	VECTOR3 off[5];
	double height;
	double diameter;
	double mass;
	char module[MAXLEN];
	char name[MAXLEN];
	//unmandatory
	
	VECTOR3 speed;
	VECTOR3 rot_speed;
	
	double volume;
	int render;
	int nMeshes;
	MESHHANDLE msh_h[5];
	int msh_idh[5];
	VECTOR3 Rotation;
	bool rotated;
	bool live;
	};
struct FAIRING{
	//mandatory
	int N;
	char meshname[MAXLEN];
	VECTOR3 off;
	double angle;
	double height;
	double diameter;
	double emptymass;
	//unmandatory
	double volume;
	VECTOR3 speed;
	VECTOR3 rot_speed;
	char module[MAXLEN];
	MESHHANDLE msh_h[10];
	int msh_idh[10];
	};
enum GNC_Comand {CM_ROLL,CM_PITCH,CM_ENGINE,CM_FAIRING,CM_LES,CM_DISABLE_PITCH,CM_DISABLE_ROLL,CM_DISABLE_JETTISON,CM_PLAY,CM_JETTISON,CM_TARGET,CM_AOA,CM_ATTITUDE,CM_SPIN,CM_INVERSE,CM_ORBIT,CM_ENGINEOUT,CM_DEFAP,CM_GLIMIT,CM_NOLINE};
struct GNC_STEP{
	double time;
	char Comand[128];
	GNC_Comand GNC_Comand;
	double val_init;
	double val_fin;
	double time_init;
	double time_fin;
	double duration;
	double trval1,trval2,trval3,trval4,trval5,trval6;
	bool executed;
	char trchar[256];
	bool wValue[6];
};
struct SSOUND{
	char MAIN_THRUST[MAXLEN];
	bool Main;
	char HOVER_THRUST[MAXLEN];
	bool Hover;
	char RCS_THRUST_ATTACK[MAXLEN];
	bool RCS_ta;
	char RCS_THRUST_SUSTAIN[MAXLEN];
	bool RCS_ts;
	char AIR_CONDITIONNING[MAXLEN];
	bool Ac;
	char COCKPIT_AMBIENCE_1[MAXLEN];
	bool Ca1;
	char COCKPIT_AMBIENCE_2[MAXLEN];
	bool Ca2;
	char COCKPIT_AMBIENCE_3[MAXLEN];
	bool Ca3;
	char COCKPIT_AMBIENCE_4[MAXLEN];
	bool Ca4;
	char COCKPIT_AMBIENCE_5[MAXLEN];
	bool Ca5;
	char COCKPIT_AMBIENCE_6[MAXLEN];
	bool Ca6;
	char COCKPIT_AMBIENCE_7[MAXLEN];
	bool Ca7;
	char COCKPIT_AMBIENCE_8[MAXLEN];
	bool Ca8;
	char COCKPIT_AMBIENCE_9[MAXLEN];
	bool Ca9;
	int GncStepSound[57];
};
struct FX_MACH{
	double mach_min;
	double mach_max;
	char pstream[MAXLEN];
	bool added;
	VECTOR3 off[10];
	VECTOR3 dir;
	PSTREAM_HANDLE ps_h[10];
	int nmach;
};
struct FX_VENT{
	double time_fin[10];
	char pstream[MAXLEN];
	VECTOR3 off[10];
	VECTOR3 dir[10];
	PSTREAM_HANDLE ps_h[10];
	bool added[10];
};

struct Fuel_Levels{
	double Stage_Fuel_Lvls[10];
	double Boosters_Fuel_Lvls[10];
};
class Multistage2015:public VESSEL3{
public:
 Multistage2015(OBJHANDLE hObj,int fmodel);
 ~Multistage2015();
 void clbkSetClassCaps(FILEHANDLE cfg);
 int clbkConsumeBufferedKey(DWORD key,bool down,char *kstate);
 void clbkLoadStateEx(FILEHANDLE scn,void *vs);
 void clbkSaveState(FILEHANDLE scn);
 void clbkPostStep(double simt, double simdt, double mjd);
 void clbkPreStep(double simt, double simdt, double mjd);
 void clbkPostCreation();
 bool clbkDrawHUD(int mode, const HUDPAINTSPEC *hps, oapi::Sketchpad *skp);
 //void clbkVisualCreated (VISHANDLE _vis, int refcount);
 //void clbkVisualDestroyed (VISHANDLE _vis, int refcount);
 int clbkGeneric (int msgid, int prm, void *context);
 int MyID;
 //VISHANDLE vis;
 THGROUP_HANDLE thg_h_main;
 
 //Making Public Some Vars
// virtual double GetTgtApo();
// virtual Fuel_Levels GetFuelLevels();
 //double testing;
 PSTREAM_HANDLE AddExhaustStreamGrowing(THRUSTER_HANDLE  th,  const VECTOR3 &  pos, PARTICLESTREAMSPEC *  pss , bool growing, double growfactor_size, double growfactor_rate, bool count) ; 
 void ManageParticles(double dt,bool prestep);
 double particlesdt;
 bool GrowingParticles;
 double RefPressure;
// UINT rotateplx[5];
 //UINT rotateply[5];
 //UINT rotateplz[5];
//private:
// I think it's better to have most of these as private
 VECTOR4 _V4(double x, double y, double z, double t);
 VECTOR2 _V2(double x, double y);
 bool IsOdd(int integer);
 GNC_STEP Gnc_step[150]; //MAx 150 Steps
 void AutoJettison();
 void initGlobalVars();
 void VehicleSetup();
 void RotatePayload(int pns, int nm, VECTOR3 anglesrad);
 void LoadMeshes();
 void UpdateMass();
 void UpdatePMI();
 double TotalHeight;
 void UpdateOffsets();
 void CreateUllageAndBolts();
 char dataparsed[MAXLEN];
 bool parseinifile(char filename[MAXLEN]);
 void parseStages(char filename[MAXLEN]);
 void parseBoosters(char filename[MAXLEN]);
 void parseInterstages(char filename[MAXLEN],int parsingstage);
 void parseAdapter(char filename[MAXLEN]);
 void parseLes(char filename[MAXLEN]);
 void parseFairing(char filename[MAXLEN]);
 void parsePayload(char filename[MAXLEN]);
 void parseMisc(char filename[MAXLEN]);
 void parseTexture(char filename[MAXLEN]);
 void parseParticle(char filename[MAXLEN]);
 void parseFXMach(char filename[MAXLEN]);
 void parseFXVent(char filename[MAXLEN]);
 void parseSound(char filename[MAXLEN]);
 VECTOR3 GetBoosterPos(int nBooster, int N);
 void ArrangePayloadMeshes(char data[MAXLEN], int pnl);
 char* GetProperPayloadMeshName(int pnl, int n);
 void ArrangePayloadOffsets(char data[MAXLEN], int pnl);
 void Jettison(int type, int current);
 void Spawn(int type, int current);
 VECTOR3 CharToVec(char charvar[MAXLEN],VECTOR3* outvec);
 VECTOR4 CharToVec4(char charvar[MAXLEN],VECTOR4* outvec);
 int Configuration;
 double CogElev;
 double VerticalAngle;
 char OrbiterRoot[MAXLEN];
 char fileini[MAXLEN];
 char guidancefile[MAXLEN];
 int nStages;
 int nBoosters;
 int nInterstages;
 int nPayloads;
 int nTextures;
 int nParticles;
 int currentStage;
 int currentBooster;
 int currentInterstage;
 int currentPayload;
 bool hasFairing;
 bool wLes;
 bool wMach;
 bool wVent;
 int wFairing;
 STAGE stage[10];
 BOOSTER booster[10];
 PAYLOAD payload[10];
 FAIRING fairing;
 MISC Misc;
 TEX tex;
 PARTICLE Particle[16];
  //PARTICLE ParticleGrowing[16];
 int nPsh;
 int nPsg;
 PSGROWING *psg;
 bool ParticleFirstLoop;
 ADAPTER Adapter;
 LES Les;
 SSOUND Ssound;
 FX_MACH FX_Mach;
 FX_VENT FX_Vent;
 void CreateRCS();
 void CreateMainThruster();
 bool wBoosters;
 bool wAdapter;
 char logbuff[MAXLEN];
 char buffreset[MAXLEN];
 double MET;
 SURFHANDLE GetProperExhaustTexture(char name[MAXLEN]);
 void FLY(double simtime, double simdtime, double mjdate);
 VECTOR3 RotateVecZ(VECTOR3 input, double Angle);
 PARTICLE GetProperPS(char name[MAXLEN]);
 void InitializeDelays();
 double stage_ignition_time;
 virtual void ToggleComplexFlight();
//bool wVinkasGuidance;
 virtual VECTOR3 hms(double time);
 virtual double RemBurnTime(int rbtstage, double level);
 virtual double BoosterRemBurnTime(int rbtbooster, double level);
 double StageDv(int dvstage);
 double DvAtStage(int dvatstage);
 double StageRemDv(int dvstage);
 double CurrentStageRemDv();
 VECTOR3 RotateVector(const VECTOR3& input, double angle, const VECTOR3& rotationaxis);
 ATTACHMENTHANDLE live_a[10];
 void UpdateLivePayloads();
 MATRIX3 RotationMatrix(VECTOR3 angles);
 void CheckForAdditionalThrust(int pns);
 void CheckForFX(int fxtype, double param);
 int nVent;
 double lvl;
 
 
 UINT exhaustN[10][32];
 virtual void WriteGNCFile();
 //GUIDANCE
 void parseGuidanceFile(char filename[MAXLEN]);
 int nsteps;
 void VinkaComposeGNCSteps();
 GNC_STEP VinkaComposeSpecificGNCSteps(GNC_STEP gnc);
 virtual void VinkaDeleteStep(int q);
 virtual void VinkaRearrangeSteps();
 virtual void VinkaAddStep(char input[MAXLEN]);
 int VinkaCountSteps();
 double perror;
 double yerror;
 double rerror;
 double pintegral;
 double kp;
 double kd;
 double ki;

 double Tu;
 double Ku;

 VECTOR3 MaxTorque;
 void Attitude(double pitch,double roll, double heading,double pitchrate, double rollrate, double yawrate);
 double VinkaAzimuth;
 double VinkaMode;
 virtual int VinkaGetStep(double met);
 void VinkaPitch(int step);
 void VinkaRoll(int step);
 void VinkaEngine(int step);
 void VinkaConsumeStep(int step);
 void VinkaAutoPilot();
 void VinkaCheckInitialMet();
 virtual double GetProperHeading();
 virtual double GetHeading();
 double GetProperRoll(double RequestedRoll);
 double initlong,initlat;
 int VinkaFindFirstPitch();
 int VinkaFindRoll();
 void VinkaUpdateRollTime();
 bool APstat;
 double finalv(double Abside, double Apo,double Peri);
 bool AJdisabled;
 bool rolldisabled;
 bool pitchdisabled;
 void killAP();
 double VinkaFindEndTime();
 int Gnc_running;
 void Guidance_Debug();
  string value1,value2,value3,value4,value5,value6;
  bool spinning;
  bool AttCtrl;
  bool PitchCtrl;
  bool YawCtrl;
  bool RollCtrl;
  virtual void ToggleAttCtrl(bool Pitch, bool Yaw, bool Roll);
  virtual void ToggleAP();
 double DeltaUpdate;
 bool wPeg;
 double TgtPitch;
 double GetVPerp();
 double altsteps[4];
 bool stepsloaded;
 virtual void SetNewAltSteps(double newstep1, double newstep2, double newstep3, double newstep4);
 bool Complex;
 void EvaluateComplexFlight();
 void ComplexFlight();
 double UpdateComplex;
 void CalculateAltSteps(double planetmass);
  ////COMPUTATIONAL GRAVITY TURN EVALUATION
  
  double GetProperNforCGTE(double time);
  bool CGTE(double psi0);
  double GT_InitPitch;
  double GT_IP_Calculated;


  //Some More Utilities
  double GetMassAtStage(int MassStage,bool empty);
  double CalcAzimuth();
  double getabsacc();
  double getacc();
  double GetOS();
  int SignOf(double X);

  void Boiloff();
	  


	  
	  
  void CalcMECO();
  
	////PEG
  bool runningPeg;
	bool CutoffCheck();
	ORBITPARAM op;
	ELEMENTS el;
	double epsfin;
	double eps;
	CUTOFF_CONDITIONS coc;
  void FEstimate();

  double MECO_TEST;
  double coeff[100];
  double avgcoeff;
  int MECO_Counter;
  double TMeco;
  void FStaging();
  	double PegPitchLimit;
	virtual void SetPegPitchLimit(double newlimit);
  double r_T[10];
  double rdot_T[10];
  double T[10];
  double DeltaA[10];
  double DeltaB[10];
  double A[10];
  double B[10];
  double delta_rdot[10];
  double delta_r[10];
  double r_in[10];
  double rdot_in[10];
  double VthetaAtStaging[10];
  double OmegaS[10];
  double a_fin[10];
  

  double tgtapo;
  double tgtperi;
  double tgtinc;
  double tgtabside;
  double tgtvv;
  double Azimuth;
double mu;
double rt;
double g0;

//Navigation vars
double r;
double v;
double z;
VECTOR3 hvec;
VECTOR3 rvec;
VECTOR3 vvec;
double h;
VECTOR3 rhat;
VECTOR3 hhat;
VECTOR3 thetahat;
VECTOR3 fhat;
double thrust;
double mass;
double a_[10];
double v_e[10];
double tau_[10];
double omega;
double rdot;
double vtheta;
VECTOR3 ShipSpeed;
double VertVel;
int NN;
double PegMajorCycleInterval;
virtual void SetPegMajorCycleInterval(double newinterval);

//feedback vars
double g;
double cent;
double g_term;
double cent_term;
int J;


void InitPEG();
void Navigate();
double b0(int j, double t_j);
double b_(int n, int j, double t_j);
double c0(int j, double t_j);
double c_(int n, int j , double t_j);
double a(int j, double t_j);

void CalculateTargets();
void MajorCycle();
double UpdatePegTimer;
double PegDesPitch;

void PEG();

//FAILURES
int failureProbability;
int timeOfFailure;
bool wFailures;
bool failed;
void Failure();
void FailuresEvaluation();
bool CheckForFailure(double met);
void boom();


//TELEMETRY
char tlmfile[MAXLEN];
VECTOR2 tlmAlt[TLMSECS];
VECTOR2 tlmSpeed[TLMSECS];
VECTOR2 tlmPitch[TLMSECS];
VECTOR2 tlmThrust[TLMSECS];
VECTOR2 tlmMass[TLMSECS];
VECTOR2 tlmVv[TLMSECS];
VECTOR2 tlmAcc[TLMSECS];
VECTOR2 ReftlmAlt[TLMSECS];
VECTOR2 ReftlmSpeed[TLMSECS];
VECTOR2 ReftlmPitch[TLMSECS];
VECTOR2 ReftlmThrust[TLMSECS];
VECTOR2 ReftlmMass[TLMSECS];
VECTOR2 ReftlmVv[TLMSECS];
VECTOR2 ReftlmAcc[TLMSECS];

double updtlm;
double writetlmTimer;
int tlmidx;
void Telemetry();
int tlmnlines;
int loadedtlmlines;
virtual int WriteTelemetryFile(int initline);
virtual void parseTelemetryFile(char filename[MAXLEN]);
double updtboiloff;
bool wReftlm;
double CalculateFullMass();


void ResetVehicle();
FILEHANDLE scenario;
FILEHANDLE config;
int loadedCurrentBooster;
int loadedCurrentInterstage;
int loadedCurrentStage;
int loadedCurrentPayload;
int loadedwFairing;
int loadedConfiguration;
double loadedMET;
VESSELSTATUS2 vs2;
bool DeveloperMode;
NOTEHANDLE note;
//void clbkSetStateEx (const void *status);

};




